program showpic;
{$G+}
uses dos;

function readkey:char; assembler;
asm
        xor     ax,ax
        int     16h
end;

procedure setmode(mode:word); assembler;
asm
        mov     ax,mode
        int     10h
end;

procedure makepal(pal:pointer); assembler;
asm
        push    ds
        lds     si,pal
	mov     dx,$3c8
        mov     cx,768
        xor     al,al

        out     dx,al
        inc     dx
        rep     outsb
        pop     ds
end;

procedure loadpic(const s:string);
var f:file;
    pic,pal:pointer;
begin
 assign(f,s);
 reset(f,1);
 getmem(pic,64000);
 getmem(pal,768);
 blockread(f,pal^,768);
 blockread(f,pic^,64000);
 makepal(pal);
 move(pic^,mem[sega000:0],64000);
 freemem(pal,768);
 freemem(pic,64000)
end;

begin
 if paramcount<>1 then
  begin
   writeln('Usage:  Showdny <filename>');
   halt;
  end;
 if fsearch(paramstr(1),'')='' then
  begin
   writeln('File not found: ',paramstr(1));
   halt
  end;
 setmode($13);
 loadpic(paramstr(1));
 readkey;
 setmode(3)
end.