program ShowMsh; {ShowMooishi}
{$G+}
uses dos;

function readkey:char; assembler;
asm
        xor     ax,ax
        int     16h
end;

procedure setmode(mode:word); assembler;
asm
        mov     ax,mode
        int     10h
end;

procedure unmooishi(pic,pal:pointer); assembler;
var TempSegA000:word;
asm
        mov     ax,Sega000
        mov     TempSegA000,ax

        push	ds

        les     di,pal

	lds	si,pic
        add	si,8		;{get past "MOOISHI!"}
        lodsw
        mov     dx,ax
        lodsw
        mov     bx,ax
;{----------------------------------GET PALETTE}
	add	si,10
	mov	cx,192
@repeat:lodsb
	shr	al,2
	stosb
	dec	si
	lodsb
	shl	al,4
	and	al,00110000b
	mov	ah,al
	lodsb
	shr	al,4
	add	al,ah
	stosb
	dec	si
	lodsb
	shl	al,2
	and	al,00111100b
	mov	ah,al
	lodsb
	shr	al,6
	add	al,ah
	stosb
	dec	si
	lodsb
	and	al,00111111b
	stosb
	loop	@repeat
;{----------------------------------GET PICTURE}
        mov     es,TempSegA000
	xor	di,di
@chewpizza:
	cmp	di,64000
	jae	@nomoremushy

	lodsb
	cmp	al,dl
	je	@longstr
	cmp	al,dh
	je	@shortstr
	cmp	al,bl
	je	@checkstr
	cmp	al,bh
	je	@checkshortstr
	dec	si
	movsb
	jmp	@chewpizza
@longstr:lodsw
	mov	cx,ax
	lodsb
	rep	stosb
	jmp	@chewpizza
@shortstr:lodsb
	mov	ch,0
	mov	cl,al
	lodsb
	rep	stosb
	jmp	@chewpizza
@checkstr:lodsw
	mov	cx,ax
	lodsw
	rep	stosw
	jmp	@chewpizza
@checkshortstr:lodsb
	mov	ch,0
	mov	cl,al
	lodsw
	rep	stosw
	jmp	@chewpizza

@nomoremushy:

        pop     ds
        push    ds

	mov     dx,$3c8
        mov     cx,768
        xor     al,al
        lds     si,pal

        out     dx,al
        inc     dx
        rep     outsb

        pop     ds
end;

procedure loadmsh(const s:string);
var f:file;
    pic,pal:pointer;
    picsize:word;
begin
 assign(f,s);
 reset(f,1);
 picsize:=filesize(f);
 getmem(pic,picsize);
 getmem(pal,768);
 blockread(f,pic^,picsize);
 close(f);
 unmooishi(pic,pal);
 freemem(pal,768);
 freemem(pic,picsize)
end;

begin
 if paramcount<>1 then
  begin
   writeln('Usage: Showmsh <filename>');
   halt
  end;
 if fsearch(paramstr(1),'')='' then
  begin
   writeln('File not found: ',paramstr(1));
   halt
  end;
 setmode($13);
 loadmsh(paramstr(1));
 readkey;
 setmode(3)
end.